﻿Imports System

Module Program
  Class SchoolMember
    Private _name As String
    Private _age As Integer
  
    'Define the constructor
    Public Sub New(n As String, a As Integer)
      Me.Name = n
      Me.Age = a
      Console.WriteLine("A school member was initialized")
    End Sub
  
    'Define public property Name
    Public Property Name
      'Define the getter
      Get
        Return Me._name
      End Get
  
      'Define the setter
      Set
        If Value <> "" Then
          Me._name = Value
        Else
          Throw New Exception("Name cannot be empty")
        End If
      End Set
    End Property
  
    'Define public property Age
    Public Property Age
      'Define the getter
      Get
        Return Me._age
      End Get
  
      'Define the setter
      Set
        If Value > 0 Then
          Me._age = Value
        Else
          Throw New Exception("Age cannot be negative or zero")
        End If
      End Set
    End Property
  End Class
  
  Class Teacher
    Inherits SchoolMember
  
    Private _salary As Double  'This is an additional field for this class
  
    'Define the constructor
    Public Sub New(n As String, a As Integer, s As Double)
      MyBase.New(n, a)
  
      Me.Salary = s
      Console.WriteLine("A teacher was initialized")
    End Sub
  
    'Define public property Salary
    Public Property Salary
      'Define the getter
      Get
        Return Me._salary
      End Get
  
      'Define the setter
      Set
        If Value >= 0 Then
          Me._salary = Value
        Else
          Throw New Exception("Salary cannot be negative")
        End If
      End Set
    End Property
  End Class
  
  Class Student
    Inherits SchoolMember
  
    Private _grades(2) As Integer  'This is an additional field for this class
  
    'Define the constructor
    Public Sub New(n As String, a As Integer, g() As Integer)
      MyBase.New(n, a)
  
      Me.Grades = g
      Console.WriteLine("A student was initialized")
    End Sub
  
    'Define public property Grades
    Public Property Grades()
      'Define the getter
      Get
        Return Me._grades
      End Get
  
      'Define the setter
      Set
        'Value here is an array. Check if negative grade exists in Value
        Dim negative_found As Boolean = False
        For Each v In Value
          If v < 0 Then
            negative_found = True
          End If
        Next
  
        If Not negative_found Then
          Me._grades = Value
        Else
          Throw New Exception("Grades cannot be negative")
        End If
      End Set
    End Property
  End Class
  
  Sub Main(args As String())
    Dim teacher1 As New Teacher("Mr. John Scott", 43, 35000)
    Dim teacher2 As New Teacher("Mrs. Ann Carter", 55, 32000)
  
    Dim student1 As New Student("Mark Nelson", 14, {90, 95, 92})
    Dim student2 As New Student("Mary Morgan", 13, {92, 97, 94})
  
    Console.WriteLine(teacher1.Name)
    Console.WriteLine(teacher1.Age)
    Console.WriteLine(teacher1.Salary)
  
    Console.WriteLine(student2.Name)
    Console.WriteLine(student2.Age)
    For Each grade In student2.Grades
      Console.WriteLine(grade)
    Next
  End Sub
End Module
